Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.basex.query.up
Class Transform

    java.lang.Object
      org.basex.query.ExprInfo
          org.basex.query.expr.Expr
              org.basex.query.expr.Arr
                  org.basex.query.up.Transform

    public final class Transform

extends Arr

Transform expression.

Author:
  Workgroup DBIS, University of Konstanz 2005-10, ISC License, Lukas Kircher

Nested Class Summary

Nested classes/interfaces inherited from class org.basex.query.expr.Expr
`Expr.Use`

Field Summary

Fields inherited from class org.basex.query.expr.Arr
`expr`

Constructor Summary
`Transform(Let[] c, Expr m, Expr r)` Constructor.

Method Summary
`Item` | `atomic(QueryContext ctx)` Evaluates the expression and returns the resulting item or a `null` reference.
`Expr` | `comp(QueryContext ctx)` Optimizes and compiles the expression.
`void` | `plan(Serializer ser)` Recursively sends the abstract syntax of this expression to the specified serializer.
`String` | `toString()`
`boolean` | `uses(Expr.Use u, QueryContext ctx)` Indicates if an expression uses the specified type.

Methods inherited from class org.basex.query.expr.Arr
`duplicates, indexEquivalent, removable, remove`

Methods inherited from class org.basex.query.expr.Expr
`addText, checkCtx, checkDbl, checkItr, e, ebv, i, indexAccessible, iter, returned, sameAs, size, test, v`

Methods inherited from class org.basex.query.ExprInfo
`color, info, name`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Transform

    public Transform(Let[] c,
                     Expr m,
                     Expr r)

  Constructor.

  Parameters:
    `c` - copy expressions
    `m` - modify expression
    `r` - return expression

Method Detail

### comp

    public Expr comp(QueryContext ctx)
              throws QueryException

  Description copied from class: `Expr`
  Optimizes and compiles the expression.

  Overrides:
    `comp` in class `Arr`
  Parameters:
    `ctx` - query context
  Returns:
    optimized Expression
  Throws:
    `QueryException` - query exception

### atomic

    public Item atomic(QueryContext ctx)
                throws QueryException

  Description copied from class: `Expr`
  Evaluates the expression and returns the resulting item or a `null` reference. If this method is not overwritten, `Expr.iter(org.basex.query.QueryContext)` must be implemented.

  Overrides:
    `atomic` in class `Expr`
  Parameters:
    `ctx` - query context
  Returns:
    iterator
  Throws:
    `QueryException` - query exception

### uses

    public boolean uses(Expr.Use u,
                        QueryContext ctx)

  Description copied from class: `Expr`
  Indicates if an expression uses the specified type. Called by the compiler to perform certain optimizations. `true` is returned by default and thus assumed as "worst-case".

  Overrides:
    `uses` in class `Arr`
  Parameters:
    `u` - use type to be checked
    `ctx` - query context
  Returns:
    result of check

### plan

    public void plan(Serializer ser)
              throws IOException

  Description copied from class: `ExprInfo`
  Recursively sends the abstract syntax of this expression to the specified serializer.

  Overrides:
    `plan` in class `Arr`
  Parameters:
    `ser` - serializer
  Throws:
    `IOException` - I/O exception

### toString

    public String toString()

  Specified by:
    `toString` in class `ExprInfo`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD